#! /usr/bin/perl

use utf8;
binmode STDOUT, 'utf8';

$ref_file = shift;
$hyp_file = shift;

%numbers = ("jeden" => 0, "dva" => 0, "tri" => 0, "štyri" => 0, "päť" => 0, "šesť" => 0,
 "sedem" => 0, "osem" => 0, "deväť" => 0, "desať" => 0, "dvadsať" => 0, "tridsať" => 0,
 "štyridsať" => 0, "päťdesiat" => 0, "šesťdesiat" => 0, "sedemdesiat" => 0, "osemdesiat" => 0,
 "deväťdesiat" => 0, "sto" => 0, "dve" => 0, "tisíc" => 0);

my @d = ();
my @B = ();
my $numMatchingSentences = 0;
my $numSentences = 0;
my $missing=0;
my $sumAcc = 0;
my $sumErr = 0;
#doplnene v4
my $sumIns = 0;
my $sumDel = 0;
my $sumSub = 0;
my $sumMatch = 0;
my $sumWords = 0;


print "loading ref\n";
open(REF,'<:encoding(UTF-8)',"$ref_file") || die "cant open $ref_file\n";
<REF>;
while(<REF>){
	chop;

	$file = $_;
	$file =~ s/\.\w+\"\r?$/\"/;#zmazeme priponu
#print $file;
	@words = ();

	#print ".\n";

	while(<REF>){
		chop;
s/\r//;
		if($_ eq "."){
		    $Ref{$file} = join(" ", @words);
		    last;
		}

		push(@words,$_);
	}
}
close(REF);

print "loading hyp\n";
open(HYP,"$hyp_file") || die "cant open $hyp_file\n";
<HYP>;
while(<HYP>){
	chop;
s/\r//;
	$file = $_;
		$file =~ s/\.\w+\"\r?$/\"/;#zmazeme priponu
	@words = ();

	#print ".\n";

	while(<HYP>){
		chop;

		if($_ eq "."){
		    $Hyp{$file} = join(" ", @words);
		    last;
		}

		s/^\s+//g;
		@tmp = split/\s+/;

		push(@words,$tmp[2]);
	}
}
close(HYP);

foreach my $file (sort keys %Hyp){
	if(exists $Ref{$file}){

		my $s_ref = postproc(lowercase(($Ref{$file})));
		my $s_hyp = postproc(lowercase(htk2utf8($Hyp{$file})));

		my $r_mat = ();
		$r_mat = getWER($s_ref, $s_hyp);

		my @mat = @$r_mat;

		my @tstack = ();
		my @hstack = ();
		my @rstack = ();

		my @temp_ref = split/\s+/,$s_ref;
		my @temp_hyp = split/\s+/,$s_hyp;
		my $str_out_ref = "";
		my $str_out_hyp = "";

		my $x = @temp_ref;    #rozmery matice
		my $y = @temp_hyp;
		my $dim_x = @temp_ref;    #rozmery matice
		my $dim_y = @temp_hyp;

		my $word_match = 0;
		my $word_del = 0;
		my $word_ins = 0;
		my $word_sub = 0;
		my $numRefWords = $x;

		my $i = $x;
		my $j = $y;

		while(1){

			last if($i == 0 || $j == 0);
		
			if($b[$i][$j] == 1){
				push(@tstack, "del");
				push(@rstack, pop(@temp_ref));
				push(@hstack, "<del>");
				$i--;
				$word_del++;
			} elsif($b[$i][$j] == 2){
				push(@tstack, "ins");
				push(@rstack, "<ins>");
				push(@hstack, pop(@temp_hyp));
				$j--;
				$word_ins++;
			} elsif($b[$i][$j] == 3){
				push(@tstack, "match");
				push(@rstack, pop(@temp_ref));
				push(@hstack, pop(@temp_hyp));
				$i--;
				$j--;
				$word_match++;
			} elsif($b[$i][$j] == 4){
				push(@tstack, "sub");
				push(@rstack, pop(@temp_ref));
				push(@hstack, pop(@temp_hyp));
				$i--;
				$j--;
				$word_sub++;
			}
		}
		
		for(my $i = $#rstack; $i >= 0; $i = $i - 1){

			my $length = length($rstack[$i]);
			$length = length($hstack[$i]) if($length < length($hstack[$i]));

			$str_out_ref .= " ".$rstack[$i];
			$str_out_hyp .= " ".$hstack[$i];

			for(my $j = 0; $j < $length - length($rstack[$i]); $j++){
				$str_out_ref .= ' ';
			}

			for(my $j = 0; $j < $length - length($hstack[$i]); $j++){
				$str_out_hyp .= ' ';
			}
		}

		my $wordErrorRate = ($word_del + $word_ins + $word_sub)/$numRefWords;
		$wordErrorRate = 1 if($wordErrorRate > 1);

		$sumAcc += ($word_match/$numRefWords);
		$sumErr += $wordErrorRate;
		#doplnene v4
		$sumIns += $word_ins;
		$sumDel += $word_del;
		$sumSub += $word_sub;
		$sumMatch += $word_match;
		$sumWords += $numRefWords;

		print "Subor: $file\n";
		print "REF: $str_out_ref\n";
		print "HYP: $str_out_hyp\n";
		print "--------------------------------------------------------------\n";
		print " ACC: " . ($word_match/$numRefWords) . "\n";
		print "   Words: $numRefWords    Matches: $word_match\n";
		print " WER: " . $wordErrorRate . "\n";
		print "   Errors: " . ($word_del + $word_ins + $word_sub) . " \(Sub: $word_sub, Ins: $word_ins, Del: $word_del\)\n";
		print "--------------------------------------------------------------\n\n";

		$numSentences++;
	} else {print "\n\nNENASIEL SOM v referencnom vetu: $file\n\n"; $missing++;}
}

my $WER = ($sumIns + $sumDel + $sumSub) / $sumWords;

print "Total: \n";
print "------ \n";
print "Words: $sumWords \t Matches: $sumMatch \t";
print "Errors: " . ($sumIns + $sumDel + $sumSub) . " \(Sub: $sumSub, Del: $sumDel, Ins: $sumIns\)\n";
print "WERsclite: ". sprintf("%.2f", $WER*100) . "%\t";
print "Correct: ". sprintf("%.2f", $sumMatch/$sumWords*100) . "%\t\t";
print "AccSclite: ". sprintf("%.2f", (1-$WER)*100) . "%\n";
print "Pocet viet: $numSentences a nenajdenych $missing\n";

print "####################################################################\n";
print " WER: ".($sumErr/$numSentences)."\n";
print " Acc: ".($sumAcc/$numSentences)."\n";
print "####################################################################\n";
#SUBS
sub getWordAccuracy() {
	my $word_match = shift;

	if ($word_match == 0 || $numRefWords == 0) {
		return 0;
	} else {
		return ($word_match / $numRefWords);
	}
}

sub getSentenceAccuracy() {
	if ($numMatchingSentences == 0 || $numSentences == 0) {
		return 0;
	} else {
		return ($numMatchingSentences / $numSentences);
	}
}


sub postproc(){
	my $sen = shift;
	my @words = split/\s+/, $sen;
	for(my $i = 0; $i < @words; $i++){
		next unless(exists $numbers{$words[$i]});

		my $j = $i;
		$i++;
		while(exists $numbers{$words[$i]}){
			$words[$j] .= $words[$i];
			$words[$i] = "";
			$i++;
		}
	}
	$sen = join(" ",@words);

	$sen =~ s/\s+/ /g;
	$sen =~ s/^ //;
	$sen =~ s/ $//;

	return $sen;
}

sub htk2utf8(){
	my $str = shift;
	my @chars = split//,$str;

	return $str if(@chars < 8);

	for(my $i = 0; $i < @chars - 7; $i++){
		next unless($chars[$i] eq "\\" && $chars[$i+1] =~ /\d/ && $chars[$i+2] =~ /\d/ && $chars[$i+3] =~ /\d/ && $chars[$i+4] eq "\\" && $chars[$i+5] =~ /\d/ && $chars[$i+6] =~ /\d/ && $chars[$i+7] =~ /\d/);

		#$chars[$i] = chr(oct($chars[$i+1].$chars[$i+2].$chars[$i+3]));
		$chars[$i] = chr((oct($chars[$i+1].$chars[$i+2].$chars[$i+3]) - 192)*64 + oct($chars[$i+5].$chars[$i+6].$chars[$i+7]) - 128);

		$chars[$i+1] = '';
		$chars[$i+2] = '';
		$chars[$i+3] = '';
                $chars[$i+4] = '';
		$chars[$i+5] = '';
		$chars[$i+6] = '';
                $chars[$i+7] = '';
	}

	return join('',@chars);
}

sub htk2win(){
	my $str = shift;
	my @chars = split//,$str;

	for(my $i = 0; $i < @chars; $i++){
		next unless($chars[$i] eq "\\" && $chars[$i+1] =~ /\d/ && $chars[$i+2] =~ /\d/ && $chars[$i+3] =~ /\d/);

		$chars[$i] = chr(oct($chars[$i+1].$chars[$i+2].$chars[$i+3]));

		$chars[$i+1] = '';
		$chars[$i+2] = '';
		$chars[$i+3] = '';
	}

	return join('',@chars);
}

sub lowercase(){
	my $word = shift;

    $word = lc($word);
    $word =~ tr<ÁÄČĎÉĚÍĹĽŇÓÖŔŘŠŤÚŮÜÝŽ><áäčďéěíĺľňóöŕřšťúůüýž>;

	return $word;
}

sub getWER(){

	my $sref = shift;
	my $shyp = shift;
	
	#print "\n$sref\n$shyp\n";

	my @ref = split/\s+/,$sref;
	my @hyp = split/\s+/,$shyp;

	@d = ();

        for(my $i = 0; $i <= @ref; $i++){
            $d[$i][0] = 1000;
        }

        for(my $j = 0; $j <= @hyp; $j++){
            $d[0][$j] = 1000;
        }

		$d[0][0] = 0;

        for(my $i = 1; $i <= @ref; $i++){
            for(my $j = 1; $j <= @hyp; $j++){
                if($ref[$i-1] eq $hyp[$j-1]){
                    $cost = 0;
                } else {
                    $cost = 1;
                }

                $d[$i][$j] = $d[$i-1][$j] + 1;
				$b[$i][$j] = 1;
                if($d[$i][$j-1] + 1 < $d[$i][$j]){
					$d[$i][$j] = $d[$i][$j-1] + 1;
					$b[$i][$j] = 2;
				}
                if($d[$i-1][$j-1] + $cost < $d[$i][$j]){
					$d[$i][$j] = $d[$i-1][$j-1] + $cost;
					$b[$i][$j] = 3;
					$b[$i][$j] = 4 if($cost);
				}
            }
        }

        #return ($d[$#ref+1][$#hyp+1] / ($#ref+1));
		#return \@d;
}

